##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (KSM-Mount)	= PkgName
# sampledir (ksm-mount)		= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (ksmmount)		= config file name (no extension)
# sampledm (ksmmountd)		= the daemon (rc-script, rc-link, systemd.service)
# sample (ksm-mount)		= all others
##############################################################################

# Specfile for KSM-Mount

%define name		ksm-mount
%define version		0.0.1
%define release		2.0.0
%define _arch		noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _sysddir	/etc/systemd/system
%define _uxbindir	/usr/bin
%define _uxsbindir	/usr/sbin
%define _bindir		/usr/local/bin
%define _sbindir	/usr/local/sbin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	Mount programs for /media
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Other
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	ksm-mountpkg,ksm-mountcapab
Requires:	ksm-lib-sh >= 4.1.0-0.0.0
#Requires:	ksm-ksm-mount = %{version}-%{release}	# if lang pkg
#Provides:	ksmmountd
#Conflicts:	ksmmountd-other,libksm-mount == 0.0.0
#Obsoletes:	myksmmountd

%description
This package contains programs for mounting file systems under /media/
The package contains the following programs:

 mntcdrom, mntdvd, mntloop-ext2, mntloop-iso9660

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/ksmmount.conf
#%config %{_confdir}/ksmmount.conf
#%config %{_scnfdir}/ksmmount
#%attr(644,root,root)%{_confdir}/ksmmount.conf
#%attr(644,root,root)%{_scnfdir}/ksmmount

#%attr(744,root,root)%{_rcdir}/ksmmountd
#%attr(777,root,root)%{_sbindir}/rcksmmountd
#%attr(744,root,root)%{_sbindir}/ksmmountd.sh

%attr(755,root,root)%{_bindir}/mntcdrom
%attr(755,root,root)%{_bindir}/mntdvd
%attr(755,root,root)%{_bindir}/mntloop-ext2
%attr(755,root,root)%{_bindir}/mntloop-iso9660

%{_datadir}/RELEASE
%{_datadir}/VERSION
%{_datadir}/ksm-mount-rule
#%attr(744,root,root)%{_datadir}/ksmmountd.rc
#%{_datadir}/ksmmountd.service

/usr/share/applications/mount-cd.desktop
/usr/share/applications/mount-dvd.desktop
/usr/share/applications/unmount-cd.desktop
/usr/share/applications/unmount-dvd.desktop

#%{_icondir}/16x16/apps/ksm-mount.png
#%{_icondir}/22x22/apps/ksm-mount.png
#%{_icondir}/32x32/apps/ksm-mount.png
#%{_icondir}/48x48/apps/ksm-mount.png
#%{_icondir}/64x64/apps/ksm-mount.png
#%{_icondir}/128x128/apps/ksm-mount.png
#%{_icondir}/256x256/apps/ksm-mount.png
#%{_icondir}/512x512/apps/ksm-mount.png
#/usr/share/pixmaps/ksm-mount.png

%docdir %{_man1dir}
%{_man1dir}/mntcdrom.1.gz
%{_man1dir}/mntdvd.1.gz
%{_man1dir}/mntloop-ext2.1.gz
%{_man1dir}/mntloop-iso9660.1.gz

%docdir %{_man8dir}
#%{_man8dir}/ksmmountd.sh.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
%{_docdir}/README.de

#---------------------- ORDER OF SCRIPTLETS ----------------------------------
# O=old pkg, N=new pkg

# INSTALL:
# 1. Run %pre section of N		(Arg is 1)
# 2. Install files from N
# 3. Run %post section of N		(Arg is 1)

# UNINSTALL:
# 1. Run %preun section of O		(Arg is 0)
# 2. Delete files from O
# 3. Run %postun section of O		(Arg is 0)

# UPGRADE:
#  1. Run %pre section of O		(Arg is 2)
#  2. Install files from N
#  3. Run %post section of N		(Arg is 2)
#  4. Execute install. triggers (%triggerin in other pkgs) set off by install N
#  5. Execute installation triggers of N
#  6. Execute uninstallation triggers (%triggerun) of O
#  7. Execute uninstallation triggers (of other pkgs) set off by uninstall O
#  8. Run %preun section of O		(Arg is 1)
#  9. Delete files from O not contained in N
# 10. Run %postun section of O		(Arg is 1)

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

#ngroup='' nuser='' npwd='' ncomm='' nhomedir='' nlogsh='' ngid=0 nuid=0 ret=0

# backup config files
#test -e %{_confdir}/ksmmount.conf && cp %{_confdir}/ksmmount.conf %{_confdir}/ksmmount.conf.rpmsave
#test -e %{_scnfdir}/ksmmount && cp %{_scnfdir}/ksmmount %{_scnfdir}/ksmmount.rpmsave

# disable ksm-mount daemon and stop ksmmountd
#test -x %{_bindir}/toggleksm-mount && %{_bindir}/toggleksm-mount -d -q > /dev/null 2>&1
#test -x %{_rcdir}/ksmmountd && %{_rcdir}/ksmmountd stop -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
#rm -f %{_libdir}/libfuncstd-sh

# uninstall desktop files
xdg-desktop-menu uninstall \
	/usr/share/applications/mount-cd.desktop \
	/usr/share/applications/mount-dvd.desktop \
	/usr/share/applications/unmount-cd.desktop \
	/usr/share/applications/unmount-dvd.desktop

# remove entries from file ksm-mount
#f=/.../ksm-mount					# pathname of file
#ft=ksm-mount						# template in datadir
#t=/tmp/ksm-mount					# tempfile
#s=ksm-mount						# flag for entries
#if [ -e $f ]; then
#	grep -q $s $f
#	ret=$?
#	if [ $ret -eq 0 ]; then
#		cat $f | grep -v $s > $t
#		cp $t $f
#		rm -f $t
#	fi
#else
#	cp %{_datadir}/$ft $f
#fi

# INIT SCRIPT/SYSTEMD UNIT - uninstall KSM-Mount
#if [ -d %{_sysddir} ]; then				# systemd
#	if [ -e %{_sysddir}/ksmmountd.service ]; then
#		systemctl stop ksmmountd.service
#		systemctl disable ksmmountd.service
#		rm %{_sysddir}/ksmmountd.service
#		systemctl daemon-reload
#	fi
#else							# SysV init
#	if [ -e %{_rcdir}/ksmmountd ]; then
#		test -x %{_rcdir}/ksmmountd && %{_rcdir}/ksmmountd stop > /dev/null 2>&1
#		insserv -r ksmmountd > /dev/null 2>&1
#		rm -f %{_rcdir}/ksmmountd
#		rm -f %{_sbindir}/rcksmmountd
#	fi
#fi

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# set config pathname and all config vars from new config file
#cf=%{_confdir}/ksmmount.conf
#cnfvars='MyVar1 MyVar2'

#c='' s='' t='' cnt=0 i=0 ret=0
#rcfile='' updcmd='' u='' usr=''

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

# enable ksm-mount daemon
#test -x %{_bindir}/toggleksm-mount && %{_bindir}/toggleksm-mount -e -q > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog
#ln -sf %{_libdir}/libfuncstd-sh-%{version} %{_libdir}/libfuncstd-sh

# install desktop files
xdg-desktop-menu install --novendor \
	/usr/share/applications/mount-cd.desktop \
	/usr/share/applications/mount-dvd.desktop \
	/usr/share/applications/unmount-cd.desktop \
	/usr/share/applications/unmount-dvd.desktop

# add entries to file ksm-mount
#f=/.../ksm-mount					# pathname of file
#te=ksm-mount.add					# templ in datadir
#cat %{_datadir}/$te >> $f

# INIT SCRIPT/SYSTEMD UNIT - install KSM-Mount
#if [ -d %{_sysddir} ]; then				# systemd
#	cp --preserve=mode %{_datadir}/ksmmountd.service %{_sysddir}/
#	systemctl daemon-reload
#	systemctl enable ksmmountd.service
#	echo "ksmmountd is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start ksmmountd within yast or manual with:"
#	echo "systemctl start ksmmountd.service"
#else							# SysV init
#	cp --preserve=mode %{_datadir}/ksmmountd.rc %{_rcdir}/ksmmountd
#	ln -sf %{_rcdir}/ksmmountd %{_sbindir}/rcksmmountd
#	insserv ksmmountd > /dev/null 2>&1
#	echo "ksmmountd is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start ksmmountd within yast or manual with rcksmmountd start"
#fi

if [ "$1" == 1 ]; then					# install package
	# cp ksm-mount-rule
	cp %{_datadir}/ksm-mount-rule /etc/sudoers.d/
	echo "Configure /etc/sudoers.d/ksm-mount-rule"
	echo "Change group users to user which should mount/umount as root."
	echo "Change host_list 'ALL' to fitted host names (localhost,www,...)."

#	echo "Configure $cf"
#	echo "Users must create HOME/.ksm-mountrc with update-ksm-mount"
#else							# upgrade package
#	# update global conf
#	if [ -e $cf.rpmsave ]; then
#		#cp $cf $cf.rpmnew
#		. $cf
#		. $cf.rpmsave
#
#		# update conf vars START -------------------------------------
#		if [ -x %{_bindir}/replcnfvar ]; then
#			for c in $cnfvars; do
#				t="\$$c"
#				eval s="$t"
#				s=\"$s\"
#				%{_bindir}/replcnfvar $cf $c "$s"
#			done
#		else
#			echo "Error - cmd replcnfvar not found or not executable!" >&2
#			echo "Conf file not updated!" >&2
#		fi
#		# update conf vars STOP --------------------------------------
#
#		# update array vars START ------------------------------------
#		# array var MainArr
#		cnt=${#MainArr[@]}			# max index of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
#			while [ "$i" -lt $cnt ]; do
#				let i++
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi
#		# update array vars STOP -------------------------------------
#
#		# compare new conf vars <--> old conf vars
#		diff $cf $cf.rpmsave > /dev/null 2>&1
#		ret=$?
#		if [ "$ret" -eq 0 ]; then
#			rm $cf.rpmsave
#		else
#			echo "Check $cf"
#		fi
#	fi
#
#	# update all users conf START ----------------------------------------
#	rcfile='.ksm-mountrc'
#	updcmd="%{_bindir}/update-ksm-mount -q"
#	usr=`/usr/bin/grep /home/ /etc/passwd | /usr/bin/cut -d : -f 1`
#	for u in "$usr"; do
#		if [ -e /home/$u/$rcfile ]; then
#			/bin/su $u -c "$updcmd"
#		fi
#	done
#	if [ -e /root/$rcfile ]; then
#		$updcmd
#	fi
#	# update all users conf STOP -----------------------------------------
#
#	echo "If new version then users must update HOME/.ksm-mountrc with update-ksm-mount"
fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

#if [ "$1" == 0 ]; then					# remove package
	# backup config files
	#test -e %{_confdir}/ksmmount.conf && cp %{_confdir}/ksmmount.conf %{_confdir}/ksmmount.conf.rpmsave
	#test -e %{_scnfdir}/ksmmount && cp %{_scnfdir}/ksmmount %{_scnfdir}/ksmmount.rpmsave

	# disable ksm-mount daemon and stop ksmmountd
	#test -x %{_bindir}/toggleksm-mount && %{_bindir}/toggleksm-mount -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/ksmmountd && %{_rcdir}/ksmmountd stop -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	#rm -f %{_libdir}/libfuncstd-sh

	# uninstall desktop files
	xdg-desktop-menu uninstall \
		/usr/share/applications/mount-cd.desktop \
		/usr/share/applications/mount-dvd.desktop \
		/usr/share/applications/unmount-cd.desktop \
		/usr/share/applications/unmount-dvd.desktop

	# remove file ksm-mount-rule
	rm /etc/sudoers.de/ksm-mount-rule

	# INIT SCRIPT/SYSTEMD UNIT - uninstall KSM-Mount
	#if [ -d %{_sysddir} ]; then				# systemd
	#	if [ -e %{_sysddir}/ksmmountd.service ]; then
	#		systemctl stop ksmmountd.service
	#		systemctl disable ksmmountd.service
	#		rm %{_sysddir}/ksmmountd.service
	#		systemctl daemon-reload
	#	fi
	#else							# SysV init
	#		test -x %{_rcdir}/ksmmountd && %{_rcdir}/ksmmountd stop > /dev/null 2>&1
	#		insserv -r ksmmountd > /dev/null 2>&1
	#		rm -f %{_rcdir}/ksmmountd
	#		rm -f %{_sbindir}/rcksmmountd
	#	fi
	#fi
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/ksm-mount
#else							# upgrade package
fi
exit 0

%changelog
* Sat Nov 12 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.1-2.0.0
- The package has been revised/improved
  (changed file ksm-mount-rule).

* Sat Nov 12 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.1-1.0.0
- Added the desktop files:
  mount-dvd.desktop, unmount-dvd.desktop

* Tue May 12 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.0.0
- The package has been revised/improved.

* Tue May 12 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.0-0.0.0
- This is the 1. version.
- The package contains following programs:
  mntcdrom		mount a CD-Rom
  mntdvd		mount a DVD
  mntloop-ext2		mount a file with loop device
  mntloop-iso9660	mount an ISO9660 file sys with loop device
